/// <summary> /// Form initialize. /// </summary> /// <param name="manager"></param> public SelectionForm(SelectionManager manager) { InitializeComponent(); m_manager = manager; }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Result Execute(Autodesk.Revit.UI.ExternalCommandData commandData, ref string message, ElementSet elements) { try { SelectionManager manager = new SelectionManager(commandData); // Create a form to select objects. DialogResult result = System.Windows.Forms.DialogResult.None; while (result == DialogResult.None || result == DialogResult.Retry) { // Picking Objects. if (result == DialogResult.Retry) { manager.SelectObjects(); } // Show the dialog. using (SelectionForm selectionForm = new SelectionForm(manager)) { result = selectionForm.ShowDialog(); } } return Autodesk.Revit.UI.Result.Succeeded; } catch (Exception ex) { // If any error, give error information and return failed message = ex.Message; return Autodesk.Revit.UI.Result.Failed; } }